# -*- coding: utf-8 -*-

"""
shelldatareportingapis

This file was automatically generated by APIMATIC v3.0 (
 https://www.apimatic.io ).
"""
from shelldatareportingapis.api_helper import APIHelper
from shelldatareportingapis.models.error_status import ErrorStatus
from shelldatareportingapis.models.usage_summary import UsageSummary


class CardUsageSummaryResponse(object):

    """Implementation of the 'CardUsageSummaryResponse' model.

    Attributes:
        usage_summary (List[UsageSummary]): The model property of type
            List[UsageSummary].
        request_id (str): API Request Id
        error (ErrorStatus): The model property of type ErrorStatus.

    """

    # Create a mapping from Model property names to API property names
    _names = {
        "usage_summary": 'UsageSummary',
        "request_id": 'RequestId',
        "error": 'Error'
    }

    _optionals = [
        'usage_summary',
        'request_id',
        'error',
    ]

    def __init__(self,
                 usage_summary=APIHelper.SKIP,
                 request_id=APIHelper.SKIP,
                 error=APIHelper.SKIP):
        """Constructor for the CardUsageSummaryResponse class"""

        # Initialize members of the class
        if usage_summary is not APIHelper.SKIP:
            self.usage_summary = usage_summary 
        if request_id is not APIHelper.SKIP:
            self.request_id = request_id 
        if error is not APIHelper.SKIP:
            self.error = error 

    @classmethod
    def from_dictionary(cls,
                        dictionary):
        """Creates an instance of this model from a dictionary

        Args:
            dictionary (dictionary): A dictionary representation of the object
            as obtained from the deserialization of the server's response. The
            keys MUST match property names in the API description.

        Returns:
            object: An instance of this structure class.

        """

        if not isinstance(dictionary, dict) or dictionary is None:
            return None

        # Extract variables from the dictionary
        usage_summary = None
        if dictionary.get('UsageSummary') is not None:
            usage_summary = [UsageSummary.from_dictionary(x) for x in dictionary.get('UsageSummary')]
        else:
            usage_summary = APIHelper.SKIP
        request_id = dictionary.get("RequestId") if dictionary.get("RequestId") else APIHelper.SKIP
        error = ErrorStatus.from_dictionary(dictionary.get('Error')) if 'Error' in dictionary.keys() else APIHelper.SKIP
        # Return an object of this model
        return cls(usage_summary,
                   request_id,
                   error)

    def __repr__(self):
        return (f'{self.__class__.__name__}('
                f'usage_summary={(self.usage_summary if hasattr(self, "usage_summary") else None)!r}, '
                f'request_id={(self.request_id if hasattr(self, "request_id") else None)!r}, '
                f'error={(self.error if hasattr(self, "error") else None)!r})')

    def __str__(self):
        return (f'{self.__class__.__name__}('
                f'usage_summary={(self.usage_summary if hasattr(self, "usage_summary") else None)!s}, '
                f'request_id={(self.request_id if hasattr(self, "request_id") else None)!s}, '
                f'error={(self.error if hasattr(self, "error") else None)!s})')
