# -*- coding: utf-8 -*-

"""
shelldatareportingapis

This file was automatically generated by APIMATIC v3.0 (
 https://www.apimatic.io ).
"""
from shelldatareportingapis.api_helper import APIHelper


class PricedRequestData(object):

    """Implementation of the 'PricedRequestData' model.

    This endpoint allows querying the transaction data (i.e. Priced, Billed
    and Unbilled sales items) from SFSBI. It provides a flexible search
    criteria and supports paging

    Attributes:
        col_co_code (str): Collecting Company Code (Shell Code) of the
            selected payer.
        col_co_id (int): The Collecting Company Id in the Shell Card Platform.
        invoice_status (PricedTransactionReqV2InvoiceStatusEnum): Invoice
            status of the transactions. Mandatory Possible options:I -
            Invoiced, U – Un-Invoiced, A – All
        payer_number (str): Payer Number of the selected payer.
        account_id (int): Account Id (GFN customer id)
        account_number (str): Account Number of the selected account.
        driver_name (str): Driver Name (of Card record)
        card_id (int): Unique Card Id in the Shell Card Platform
        card_group_id (int): Card Group Id in GFN
        card_pan (str): Full Card PAN
        product_code (str): Product Code – Global as per GFN configuration
        product_name (str): Product Name – Global as per GFN configuration
        site_code (str): Site Code in GFN
        incoming_site_number (str): Site Code as configured in GFN
        invoice_date (str): Returns the billed transaction for the given
            invoice date
        invoice_number (str): Returns the billed transaction for the given
            invoice number
        purchased_in_country_code (str): Purchased InCountryCode
        purchased_in_country (str): Network Delco PurchasedCountryName
        site_group_id (int): Site Group Id in GFN
        vehicle_registration_number (str): Vehicle Registration (of Card
            record)
        fee_type_id (int): Card Id (i.e. Unique Card Id in GFN)
        line_item_description (str): Item identifier in the transaction.
        cards (List[int]): This entity accepts the list of CardId to filter in
            the response. Note: The number of cardId allowed to be passed in
            the request is configurable to a maximum of 500 cards.
        sort_order (PricedTransactionReqV2SortOrderEnum): The model property
            of type PricedTransactionReqV2SortOrderEnum.
        from_date (str): From transaction delivery date
        to_date (str): To transaction delivery date
        period (PricedTransactionReqV2PeriodEnum): Pass below one of the value
            as per the required transaction period 1. Last 7 Days 2. Last 30
            Days 3. Last 90 Days
        posting_date_from (str): Transaction posting start date and time
        posting_date_to (str): Transaction posting end date and time
        transaction_item_id (str): Unique id of the transaction that may
            include one or more salesitems
        fuel_only (bool): Is FuelOnly indicator
        include_fees (bool): When passed as ‘true’ then all sales items along
            with fees will be included in the response and the follwoing
            filteres will be ignored * InvoiceNumber * InvoiceDate *
            PostingDateFrom * PostingDateTo
        is_multipayer (bool): If true then returns all the data linked tothe
            payer group of the provided PayerNumberin the request
        valid_invoice_date_only (bool): When passed as ‘True’ the transactions
            records with report date not equal to 9999-12-30 will be returned.
            When passed as ‘False’ the above condition will not be checked.
        invoice_from_date (str): Invoice From Date, this is a search criterion
            to filter invoiced transactions with invoice date from this date.
        invoice_to_date (str): Invoice To Date, this is a search criterion to
            filter invoiced transactions with invoice date until this date.
        hosting_collecting_company_number (str): Hosting Collecting Company
            Number of the selected payer.
        search (str): Search based on DriverName or VRN
        transaction_id (str): Unique id of the transaction that may include
            one or more salesitems

    """

    # Create a mapping from Model property names to API property names
    _names = {
        "col_co_code": 'ColCoCode',
        "invoice_status": 'InvoiceStatus',
        "payer_number": 'PayerNumber',
        "col_co_id": 'ColCoId',
        "account_id": 'AccountId',
        "account_number": 'AccountNumber',
        "driver_name": 'DriverName',
        "card_id": 'CardId',
        "card_group_id": 'CardGroupId',
        "card_pan": 'CardPAN',
        "product_code": 'ProductCode',
        "product_name": 'ProductName',
        "site_code": 'SiteCode',
        "incoming_site_number": 'IncomingSiteNumber',
        "invoice_date": 'InvoiceDate',
        "invoice_number": 'InvoiceNumber',
        "purchased_in_country_code": 'PurchasedInCountryCode',
        "purchased_in_country": 'PurchasedInCountry',
        "site_group_id": 'SiteGroupId',
        "vehicle_registration_number": 'VehicleRegistrationNumber',
        "fee_type_id": 'FeeTypeId',
        "line_item_description": 'LineItemDescription',
        "cards": 'Cards',
        "sort_order": 'SortOrder',
        "from_date": 'FromDate',
        "to_date": 'ToDate',
        "period": 'Period',
        "posting_date_from": 'PostingDateFrom',
        "posting_date_to": 'PostingDateTo',
        "transaction_item_id": 'TransactionItemId',
        "fuel_only": 'FuelOnly',
        "include_fees": 'IncludeFees',
        "is_multipayer": 'IsMultipayer',
        "valid_invoice_date_only": 'ValidInvoiceDateOnly',
        "invoice_from_date": 'InvoiceFromDate',
        "invoice_to_date": 'InvoiceToDate',
        "hosting_collecting_company_number": 'HostingCollectingCompanyNumber',
        "search": 'Search',
        "transaction_id": 'TransactionId'
    }

    _optionals = [
        'col_co_id',
        'account_id',
        'account_number',
        'driver_name',
        'card_id',
        'card_group_id',
        'card_pan',
        'product_code',
        'product_name',
        'site_code',
        'incoming_site_number',
        'invoice_date',
        'invoice_number',
        'purchased_in_country_code',
        'purchased_in_country',
        'site_group_id',
        'vehicle_registration_number',
        'fee_type_id',
        'line_item_description',
        'cards',
        'sort_order',
        'from_date',
        'to_date',
        'period',
        'posting_date_from',
        'posting_date_to',
        'transaction_item_id',
        'fuel_only',
        'include_fees',
        'is_multipayer',
        'valid_invoice_date_only',
        'invoice_from_date',
        'invoice_to_date',
        'hosting_collecting_company_number',
        'search',
        'transaction_id',
    ]

    _nullables = [
        'col_co_code',
        'payer_number',
        'account_id',
        'account_number',
        'driver_name',
        'card_group_id',
        'card_pan',
        'product_code',
        'product_name',
        'site_code',
        'incoming_site_number',
        'invoice_date',
        'invoice_number',
        'purchased_in_country_code',
        'purchased_in_country',
        'site_group_id',
        'vehicle_registration_number',
        'fee_type_id',
        'line_item_description',
        'from_date',
        'to_date',
        'posting_date_from',
        'posting_date_to',
        'transaction_item_id',
        'fuel_only',
        'include_fees',
        'invoice_from_date',
        'invoice_to_date',
        'hosting_collecting_company_number',
        'search',
        'transaction_id',
    ]

    def __init__(self,
                 col_co_code=None,
                 invoice_status=None,
                 payer_number=None,
                 col_co_id=APIHelper.SKIP,
                 account_id=APIHelper.SKIP,
                 account_number=APIHelper.SKIP,
                 driver_name=APIHelper.SKIP,
                 card_id=APIHelper.SKIP,
                 card_group_id=APIHelper.SKIP,
                 card_pan=APIHelper.SKIP,
                 product_code=APIHelper.SKIP,
                 product_name=APIHelper.SKIP,
                 site_code=APIHelper.SKIP,
                 incoming_site_number=APIHelper.SKIP,
                 invoice_date=APIHelper.SKIP,
                 invoice_number=APIHelper.SKIP,
                 purchased_in_country_code=APIHelper.SKIP,
                 purchased_in_country=APIHelper.SKIP,
                 site_group_id=APIHelper.SKIP,
                 vehicle_registration_number=APIHelper.SKIP,
                 fee_type_id=APIHelper.SKIP,
                 line_item_description=APIHelper.SKIP,
                 cards=APIHelper.SKIP,
                 sort_order=APIHelper.SKIP,
                 from_date=APIHelper.SKIP,
                 to_date=APIHelper.SKIP,
                 period=APIHelper.SKIP,
                 posting_date_from=APIHelper.SKIP,
                 posting_date_to=APIHelper.SKIP,
                 transaction_item_id=APIHelper.SKIP,
                 fuel_only=False,
                 include_fees=APIHelper.SKIP,
                 is_multipayer=APIHelper.SKIP,
                 valid_invoice_date_only=False,
                 invoice_from_date=APIHelper.SKIP,
                 invoice_to_date=APIHelper.SKIP,
                 hosting_collecting_company_number=APIHelper.SKIP,
                 search=APIHelper.SKIP,
                 transaction_id=APIHelper.SKIP):
        """Constructor for the PricedRequestData class"""

        # Initialize members of the class
        self.col_co_code = col_co_code 
        if col_co_id is not APIHelper.SKIP:
            self.col_co_id = col_co_id 
        self.invoice_status = invoice_status 
        self.payer_number = payer_number 
        if account_id is not APIHelper.SKIP:
            self.account_id = account_id 
        if account_number is not APIHelper.SKIP:
            self.account_number = account_number 
        if driver_name is not APIHelper.SKIP:
            self.driver_name = driver_name 
        if card_id is not APIHelper.SKIP:
            self.card_id = card_id 
        if card_group_id is not APIHelper.SKIP:
            self.card_group_id = card_group_id 
        if card_pan is not APIHelper.SKIP:
            self.card_pan = card_pan 
        if product_code is not APIHelper.SKIP:
            self.product_code = product_code 
        if product_name is not APIHelper.SKIP:
            self.product_name = product_name 
        if site_code is not APIHelper.SKIP:
            self.site_code = site_code 
        if incoming_site_number is not APIHelper.SKIP:
            self.incoming_site_number = incoming_site_number 
        if invoice_date is not APIHelper.SKIP:
            self.invoice_date = invoice_date 
        if invoice_number is not APIHelper.SKIP:
            self.invoice_number = invoice_number 
        if purchased_in_country_code is not APIHelper.SKIP:
            self.purchased_in_country_code = purchased_in_country_code 
        if purchased_in_country is not APIHelper.SKIP:
            self.purchased_in_country = purchased_in_country 
        if site_group_id is not APIHelper.SKIP:
            self.site_group_id = site_group_id 
        if vehicle_registration_number is not APIHelper.SKIP:
            self.vehicle_registration_number = vehicle_registration_number 
        if fee_type_id is not APIHelper.SKIP:
            self.fee_type_id = fee_type_id 
        if line_item_description is not APIHelper.SKIP:
            self.line_item_description = line_item_description 
        if cards is not APIHelper.SKIP:
            self.cards = cards 
        if sort_order is not APIHelper.SKIP:
            self.sort_order = sort_order 
        if from_date is not APIHelper.SKIP:
            self.from_date = from_date 
        if to_date is not APIHelper.SKIP:
            self.to_date = to_date 
        if period is not APIHelper.SKIP:
            self.period = period 
        if posting_date_from is not APIHelper.SKIP:
            self.posting_date_from = posting_date_from 
        if posting_date_to is not APIHelper.SKIP:
            self.posting_date_to = posting_date_to 
        if transaction_item_id is not APIHelper.SKIP:
            self.transaction_item_id = transaction_item_id 
        self.fuel_only = fuel_only 
        if include_fees is not APIHelper.SKIP:
            self.include_fees = include_fees 
        if is_multipayer is not APIHelper.SKIP:
            self.is_multipayer = is_multipayer 
        self.valid_invoice_date_only = valid_invoice_date_only 
        if invoice_from_date is not APIHelper.SKIP:
            self.invoice_from_date = invoice_from_date 
        if invoice_to_date is not APIHelper.SKIP:
            self.invoice_to_date = invoice_to_date 
        if hosting_collecting_company_number is not APIHelper.SKIP:
            self.hosting_collecting_company_number = hosting_collecting_company_number 
        if search is not APIHelper.SKIP:
            self.search = search 
        if transaction_id is not APIHelper.SKIP:
            self.transaction_id = transaction_id 

    @classmethod
    def from_dictionary(cls,
                        dictionary):
        """Creates an instance of this model from a dictionary

        Args:
            dictionary (dictionary): A dictionary representation of the object
            as obtained from the deserialization of the server's response. The
            keys MUST match property names in the API description.

        Returns:
            object: An instance of this structure class.

        """

        if not isinstance(dictionary, dict) or dictionary is None:
            return None

        # Extract variables from the dictionary
        col_co_code = dictionary.get("ColCoCode") if dictionary.get("ColCoCode") else None
        invoice_status = dictionary.get("InvoiceStatus") if dictionary.get("InvoiceStatus") else None
        payer_number = dictionary.get("PayerNumber") if dictionary.get("PayerNumber") else None
        col_co_id = dictionary.get("ColCoId") if dictionary.get("ColCoId") else APIHelper.SKIP
        account_id = dictionary.get("AccountId") if "AccountId" in dictionary.keys() else APIHelper.SKIP
        account_number = dictionary.get("AccountNumber") if "AccountNumber" in dictionary.keys() else APIHelper.SKIP
        driver_name = dictionary.get("DriverName") if "DriverName" in dictionary.keys() else APIHelper.SKIP
        card_id = dictionary.get("CardId") if dictionary.get("CardId") else APIHelper.SKIP
        card_group_id = dictionary.get("CardGroupId") if "CardGroupId" in dictionary.keys() else APIHelper.SKIP
        card_pan = dictionary.get("CardPAN") if "CardPAN" in dictionary.keys() else APIHelper.SKIP
        product_code = dictionary.get("ProductCode") if "ProductCode" in dictionary.keys() else APIHelper.SKIP
        product_name = dictionary.get("ProductName") if "ProductName" in dictionary.keys() else APIHelper.SKIP
        site_code = dictionary.get("SiteCode") if "SiteCode" in dictionary.keys() else APIHelper.SKIP
        incoming_site_number = dictionary.get("IncomingSiteNumber") if "IncomingSiteNumber" in dictionary.keys() else APIHelper.SKIP
        invoice_date = dictionary.get("InvoiceDate") if "InvoiceDate" in dictionary.keys() else APIHelper.SKIP
        invoice_number = dictionary.get("InvoiceNumber") if "InvoiceNumber" in dictionary.keys() else APIHelper.SKIP
        purchased_in_country_code = dictionary.get("PurchasedInCountryCode") if "PurchasedInCountryCode" in dictionary.keys() else APIHelper.SKIP
        purchased_in_country = dictionary.get("PurchasedInCountry") if "PurchasedInCountry" in dictionary.keys() else APIHelper.SKIP
        site_group_id = dictionary.get("SiteGroupId") if "SiteGroupId" in dictionary.keys() else APIHelper.SKIP
        vehicle_registration_number = dictionary.get("VehicleRegistrationNumber") if "VehicleRegistrationNumber" in dictionary.keys() else APIHelper.SKIP
        fee_type_id = dictionary.get("FeeTypeId") if "FeeTypeId" in dictionary.keys() else APIHelper.SKIP
        line_item_description = dictionary.get("LineItemDescription") if "LineItemDescription" in dictionary.keys() else APIHelper.SKIP
        cards = dictionary.get("Cards") if dictionary.get("Cards") else APIHelper.SKIP
        sort_order = dictionary.get("SortOrder") if dictionary.get("SortOrder") else APIHelper.SKIP
        from_date = dictionary.get("FromDate") if "FromDate" in dictionary.keys() else APIHelper.SKIP
        to_date = dictionary.get("ToDate") if "ToDate" in dictionary.keys() else APIHelper.SKIP
        period = dictionary.get("Period") if dictionary.get("Period") else APIHelper.SKIP
        posting_date_from = dictionary.get("PostingDateFrom") if "PostingDateFrom" in dictionary.keys() else APIHelper.SKIP
        posting_date_to = dictionary.get("PostingDateTo") if "PostingDateTo" in dictionary.keys() else APIHelper.SKIP
        transaction_item_id = dictionary.get("TransactionItemId") if "TransactionItemId" in dictionary.keys() else APIHelper.SKIP
        fuel_only = dictionary.get("FuelOnly") if dictionary.get("FuelOnly") else False
        include_fees = dictionary.get("IncludeFees") if "IncludeFees" in dictionary.keys() else APIHelper.SKIP
        is_multipayer = dictionary.get("IsMultipayer") if "IsMultipayer" in dictionary.keys() else APIHelper.SKIP
        valid_invoice_date_only = dictionary.get("ValidInvoiceDateOnly") if dictionary.get("ValidInvoiceDateOnly") else False
        invoice_from_date = dictionary.get("InvoiceFromDate") if "InvoiceFromDate" in dictionary.keys() else APIHelper.SKIP
        invoice_to_date = dictionary.get("InvoiceToDate") if "InvoiceToDate" in dictionary.keys() else APIHelper.SKIP
        hosting_collecting_company_number = dictionary.get("HostingCollectingCompanyNumber") if "HostingCollectingCompanyNumber" in dictionary.keys() else APIHelper.SKIP
        search = dictionary.get("Search") if "Search" in dictionary.keys() else APIHelper.SKIP
        transaction_id = dictionary.get("TransactionId") if "TransactionId" in dictionary.keys() else APIHelper.SKIP
        # Return an object of this model
        return cls(col_co_code,
                   invoice_status,
                   payer_number,
                   col_co_id,
                   account_id,
                   account_number,
                   driver_name,
                   card_id,
                   card_group_id,
                   card_pan,
                   product_code,
                   product_name,
                   site_code,
                   incoming_site_number,
                   invoice_date,
                   invoice_number,
                   purchased_in_country_code,
                   purchased_in_country,
                   site_group_id,
                   vehicle_registration_number,
                   fee_type_id,
                   line_item_description,
                   cards,
                   sort_order,
                   from_date,
                   to_date,
                   period,
                   posting_date_from,
                   posting_date_to,
                   transaction_item_id,
                   fuel_only,
                   include_fees,
                   is_multipayer,
                   valid_invoice_date_only,
                   invoice_from_date,
                   invoice_to_date,
                   hosting_collecting_company_number,
                   search,
                   transaction_id)

    def __repr__(self):
        return (f'{self.__class__.__name__}('
                f'col_co_code={self.col_co_code!r}, '
                f'col_co_id={(self.col_co_id if hasattr(self, "col_co_id") else None)!r}, '
                f'invoice_status={self.invoice_status!r}, '
                f'payer_number={self.payer_number!r}, '
                f'account_id={(self.account_id if hasattr(self, "account_id") else None)!r}, '
                f'account_number={(self.account_number if hasattr(self, "account_number") else None)!r}, '
                f'driver_name={(self.driver_name if hasattr(self, "driver_name") else None)!r}, '
                f'card_id={(self.card_id if hasattr(self, "card_id") else None)!r}, '
                f'card_group_id={(self.card_group_id if hasattr(self, "card_group_id") else None)!r}, '
                f'card_pan={(self.card_pan if hasattr(self, "card_pan") else None)!r}, '
                f'product_code={(self.product_code if hasattr(self, "product_code") else None)!r}, '
                f'product_name={(self.product_name if hasattr(self, "product_name") else None)!r}, '
                f'site_code={(self.site_code if hasattr(self, "site_code") else None)!r}, '
                f'incoming_site_number={(self.incoming_site_number if hasattr(self, "incoming_site_number") else None)!r}, '
                f'invoice_date={(self.invoice_date if hasattr(self, "invoice_date") else None)!r}, '
                f'invoice_number={(self.invoice_number if hasattr(self, "invoice_number") else None)!r}, '
                f'purchased_in_country_code={(self.purchased_in_country_code if hasattr(self, "purchased_in_country_code") else None)!r}, '
                f'purchased_in_country={(self.purchased_in_country if hasattr(self, "purchased_in_country") else None)!r}, '
                f'site_group_id={(self.site_group_id if hasattr(self, "site_group_id") else None)!r}, '
                f'vehicle_registration_number={(self.vehicle_registration_number if hasattr(self, "vehicle_registration_number") else None)!r}, '
                f'fee_type_id={(self.fee_type_id if hasattr(self, "fee_type_id") else None)!r}, '
                f'line_item_description={(self.line_item_description if hasattr(self, "line_item_description") else None)!r}, '
                f'cards={(self.cards if hasattr(self, "cards") else None)!r}, '
                f'sort_order={(self.sort_order if hasattr(self, "sort_order") else None)!r}, '
                f'from_date={(self.from_date if hasattr(self, "from_date") else None)!r}, '
                f'to_date={(self.to_date if hasattr(self, "to_date") else None)!r}, '
                f'period={(self.period if hasattr(self, "period") else None)!r}, '
                f'posting_date_from={(self.posting_date_from if hasattr(self, "posting_date_from") else None)!r}, '
                f'posting_date_to={(self.posting_date_to if hasattr(self, "posting_date_to") else None)!r}, '
                f'transaction_item_id={(self.transaction_item_id if hasattr(self, "transaction_item_id") else None)!r}, '
                f'fuel_only={(self.fuel_only if hasattr(self, "fuel_only") else None)!r}, '
                f'include_fees={(self.include_fees if hasattr(self, "include_fees") else None)!r}, '
                f'is_multipayer={(self.is_multipayer if hasattr(self, "is_multipayer") else None)!r}, '
                f'valid_invoice_date_only={(self.valid_invoice_date_only if hasattr(self, "valid_invoice_date_only") else None)!r}, '
                f'invoice_from_date={(self.invoice_from_date if hasattr(self, "invoice_from_date") else None)!r}, '
                f'invoice_to_date={(self.invoice_to_date if hasattr(self, "invoice_to_date") else None)!r}, '
                f'hosting_collecting_company_number={(self.hosting_collecting_company_number if hasattr(self, "hosting_collecting_company_number") else None)!r}, '
                f'search={(self.search if hasattr(self, "search") else None)!r}, '
                f'transaction_id={(self.transaction_id if hasattr(self, "transaction_id") else None)!r})')

    def __str__(self):
        return (f'{self.__class__.__name__}('
                f'col_co_code={self.col_co_code!s}, '
                f'col_co_id={(self.col_co_id if hasattr(self, "col_co_id") else None)!s}, '
                f'invoice_status={self.invoice_status!s}, '
                f'payer_number={self.payer_number!s}, '
                f'account_id={(self.account_id if hasattr(self, "account_id") else None)!s}, '
                f'account_number={(self.account_number if hasattr(self, "account_number") else None)!s}, '
                f'driver_name={(self.driver_name if hasattr(self, "driver_name") else None)!s}, '
                f'card_id={(self.card_id if hasattr(self, "card_id") else None)!s}, '
                f'card_group_id={(self.card_group_id if hasattr(self, "card_group_id") else None)!s}, '
                f'card_pan={(self.card_pan if hasattr(self, "card_pan") else None)!s}, '
                f'product_code={(self.product_code if hasattr(self, "product_code") else None)!s}, '
                f'product_name={(self.product_name if hasattr(self, "product_name") else None)!s}, '
                f'site_code={(self.site_code if hasattr(self, "site_code") else None)!s}, '
                f'incoming_site_number={(self.incoming_site_number if hasattr(self, "incoming_site_number") else None)!s}, '
                f'invoice_date={(self.invoice_date if hasattr(self, "invoice_date") else None)!s}, '
                f'invoice_number={(self.invoice_number if hasattr(self, "invoice_number") else None)!s}, '
                f'purchased_in_country_code={(self.purchased_in_country_code if hasattr(self, "purchased_in_country_code") else None)!s}, '
                f'purchased_in_country={(self.purchased_in_country if hasattr(self, "purchased_in_country") else None)!s}, '
                f'site_group_id={(self.site_group_id if hasattr(self, "site_group_id") else None)!s}, '
                f'vehicle_registration_number={(self.vehicle_registration_number if hasattr(self, "vehicle_registration_number") else None)!s}, '
                f'fee_type_id={(self.fee_type_id if hasattr(self, "fee_type_id") else None)!s}, '
                f'line_item_description={(self.line_item_description if hasattr(self, "line_item_description") else None)!s}, '
                f'cards={(self.cards if hasattr(self, "cards") else None)!s}, '
                f'sort_order={(self.sort_order if hasattr(self, "sort_order") else None)!s}, '
                f'from_date={(self.from_date if hasattr(self, "from_date") else None)!s}, '
                f'to_date={(self.to_date if hasattr(self, "to_date") else None)!s}, '
                f'period={(self.period if hasattr(self, "period") else None)!s}, '
                f'posting_date_from={(self.posting_date_from if hasattr(self, "posting_date_from") else None)!s}, '
                f'posting_date_to={(self.posting_date_to if hasattr(self, "posting_date_to") else None)!s}, '
                f'transaction_item_id={(self.transaction_item_id if hasattr(self, "transaction_item_id") else None)!s}, '
                f'fuel_only={(self.fuel_only if hasattr(self, "fuel_only") else None)!s}, '
                f'include_fees={(self.include_fees if hasattr(self, "include_fees") else None)!s}, '
                f'is_multipayer={(self.is_multipayer if hasattr(self, "is_multipayer") else None)!s}, '
                f'valid_invoice_date_only={(self.valid_invoice_date_only if hasattr(self, "valid_invoice_date_only") else None)!s}, '
                f'invoice_from_date={(self.invoice_from_date if hasattr(self, "invoice_from_date") else None)!s}, '
                f'invoice_to_date={(self.invoice_to_date if hasattr(self, "invoice_to_date") else None)!s}, '
                f'hosting_collecting_company_number={(self.hosting_collecting_company_number if hasattr(self, "hosting_collecting_company_number") else None)!s}, '
                f'search={(self.search if hasattr(self, "search") else None)!s}, '
                f'transaction_id={(self.transaction_id if hasattr(self, "transaction_id") else None)!s})')
