# -*- coding: utf-8 -*-

"""
shelldatareportingapis

This file was automatically generated by APIMATIC v3.0 (
 https://www.apimatic.io ).
"""
from shelldatareportingapis.api_helper import APIHelper
from shelldatareportingapis.models.search_documents_invoice import SearchDocumentsInvoice


class SearchDocumentsResponse(object):

    """Implementation of the 'SearchDocumentsResponse' model.

    Attributes:
        request_id (str): UUID (according to RFC 4122 standards) for requests
            and responses. This will be played back in the response from the
            request.
        status (str): Indicates overall status of the request. Allowed values:
            SUCCES, FAILED
        data (List[SearchDocumentsInvoice]): The model property of type
            List[SearchDocumentsInvoice].
        total_records (int): Total number of elements corresponding to the
            request
        total_records_on_page (int): Number of elements in the page content.
            Will be lesser or equal to the size param.
        is_first_page (bool): True if it is the first page, false otherwise
        is_last_page (bool): True if it is the last page, false, otherwise.

    """

    # Create a mapping from Model property names to API property names
    _names = {
        "request_id": 'RequestId',
        "status": 'Status',
        "data": 'Data',
        "total_records": 'TotalRecords',
        "total_records_on_page": 'TotalRecordsOnPage',
        "is_first_page": 'IsFirstPage',
        "is_last_page": 'IsLastPage'
    }

    _optionals = [
        'request_id',
        'status',
        'data',
        'total_records',
        'total_records_on_page',
        'is_first_page',
        'is_last_page',
    ]

    def __init__(self,
                 request_id=APIHelper.SKIP,
                 status=APIHelper.SKIP,
                 data=APIHelper.SKIP,
                 total_records=APIHelper.SKIP,
                 total_records_on_page=APIHelper.SKIP,
                 is_first_page=APIHelper.SKIP,
                 is_last_page=APIHelper.SKIP):
        """Constructor for the SearchDocumentsResponse class"""

        # Initialize members of the class
        if request_id is not APIHelper.SKIP:
            self.request_id = request_id 
        if status is not APIHelper.SKIP:
            self.status = status 
        if data is not APIHelper.SKIP:
            self.data = data 
        if total_records is not APIHelper.SKIP:
            self.total_records = total_records 
        if total_records_on_page is not APIHelper.SKIP:
            self.total_records_on_page = total_records_on_page 
        if is_first_page is not APIHelper.SKIP:
            self.is_first_page = is_first_page 
        if is_last_page is not APIHelper.SKIP:
            self.is_last_page = is_last_page 

    @classmethod
    def from_dictionary(cls,
                        dictionary):
        """Creates an instance of this model from a dictionary

        Args:
            dictionary (dictionary): A dictionary representation of the object
            as obtained from the deserialization of the server's response. The
            keys MUST match property names in the API description.

        Returns:
            object: An instance of this structure class.

        """

        if not isinstance(dictionary, dict) or dictionary is None:
            return None

        # Extract variables from the dictionary
        request_id = dictionary.get("RequestId") if dictionary.get("RequestId") else APIHelper.SKIP
        status = dictionary.get("Status") if dictionary.get("Status") else APIHelper.SKIP
        data = None
        if dictionary.get('Data') is not None:
            data = [SearchDocumentsInvoice.from_dictionary(x) for x in dictionary.get('Data')]
        else:
            data = APIHelper.SKIP
        total_records = dictionary.get("TotalRecords") if dictionary.get("TotalRecords") else APIHelper.SKIP
        total_records_on_page = dictionary.get("TotalRecordsOnPage") if dictionary.get("TotalRecordsOnPage") else APIHelper.SKIP
        is_first_page = dictionary.get("IsFirstPage") if "IsFirstPage" in dictionary.keys() else APIHelper.SKIP
        is_last_page = dictionary.get("IsLastPage") if "IsLastPage" in dictionary.keys() else APIHelper.SKIP
        # Return an object of this model
        return cls(request_id,
                   status,
                   data,
                   total_records,
                   total_records_on_page,
                   is_first_page,
                   is_last_page)

    def __repr__(self):
        return (f'{self.__class__.__name__}('
                f'request_id={(self.request_id if hasattr(self, "request_id") else None)!r}, '
                f'status={(self.status if hasattr(self, "status") else None)!r}, '
                f'data={(self.data if hasattr(self, "data") else None)!r}, '
                f'total_records={(self.total_records if hasattr(self, "total_records") else None)!r}, '
                f'total_records_on_page={(self.total_records_on_page if hasattr(self, "total_records_on_page") else None)!r}, '
                f'is_first_page={(self.is_first_page if hasattr(self, "is_first_page") else None)!r}, '
                f'is_last_page={(self.is_last_page if hasattr(self, "is_last_page") else None)!r})')

    def __str__(self):
        return (f'{self.__class__.__name__}('
                f'request_id={(self.request_id if hasattr(self, "request_id") else None)!s}, '
                f'status={(self.status if hasattr(self, "status") else None)!s}, '
                f'data={(self.data if hasattr(self, "data") else None)!s}, '
                f'total_records={(self.total_records if hasattr(self, "total_records") else None)!s}, '
                f'total_records_on_page={(self.total_records_on_page if hasattr(self, "total_records_on_page") else None)!s}, '
                f'is_first_page={(self.is_first_page if hasattr(self, "is_first_page") else None)!s}, '
                f'is_last_page={(self.is_last_page if hasattr(self, "is_last_page") else None)!s})')
